
Blockly.Msg.LOOPS_HUE = 320;
Blockly.Constants.Loops.HUE = Blockly.Msg.LOOPS_HUE;

var blocklyArea = document.getElementById('blocklyArea');
var blocklyDiv = document.getElementById('blocklyDiv');
var workspace = Blockly.inject(blocklyDiv,
      {toolbox: document.getElementById('toolbox'),
         zoom:
           {controls: true,
            wheel: true,
            startScale: 1.0,
            maxScale: 2,
            minScale: 0.5,
            scaleSpeed: 1.2},
         trashcan: true});

var onresize = function(e) {
    // Compute the absolute coordinates and dimensions of blocklyArea.
    var element = blocklyArea;
    var x = 0;
    var y = 0;
    do {
      x += element.offsetLeft;
      y += element.offsetTop;
      element = element.offsetParent;
    } while (element);
    // Position blocklyDiv over blocklyArea.
    blocklyDiv.style.left = x + 'px';
    blocklyDiv.style.top = y + 'px';
    blocklyDiv.style.width = blocklyArea.offsetWidth + 'px';
    blocklyDiv.style.height = blocklyArea.offsetHeight + 'px';
    Blockly.svgResize(workspace);
  };

window.addEventListener('resize', onresize, false);
onresize();
Blockly.svgResize(workspace);

function myUpdateFunction(event) {
  var code = Blockly.Python.workspaceToCode(workspace);
  // document.getElementById('editeurArea').innerHTML = code;
  editor.setValue(code);
}

workspace.addChangeListener(myUpdateFunction);

// Affectations

function createVariableBool(button) {
  Blockly.Variables.createVariable(button.getTargetWorkspace(), null, 'Boolean')
}

workspace.registerButtonCallback('createvariablebool', createVariableBool)

affectationsFlyoutCallback = function(workspace) {
  var xmlList = [];
  var blockText = '<block type="block_print"></block>';
  var block = Blockly.Xml.textToDom(blockText);
  xmlList.push(block);
  var listevarint = workspace.getVariablesOfType("Number");
  for (var i = 0; i < listevarint.length; i++) {
    blockText = '<block type="block_set_int"> <field name="VAR" variabletype="Number">' + listevarint[i].name + '</field></block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  var listevarbool = workspace.getVariablesOfType("Boolean");
  for (var i = 0; i < listevarbool.length; i++) {
    blockText = '<block type="block_set_bool"> <field name="VAR" variabletype="Boolean">' + listevarbool[i].name + '</field></block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  var listevarstring = workspace.getVariablesOfType("String");
  for (var i = 0; i < listevarstring.length; i++) {
    blockText = '<block type="block_set_str"> <field name="VAR" variabletype="String">' + listevarstring[i].name + '</field></block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  return xmlList;
};

workspace.registerToolboxCategoryCallback(
  'AFFECTATIONS', affectationsFlyoutCallback);

// bool

function createVariableBool(button) {
  Blockly.Variables.createVariable(button.getTargetWorkspace(), null, 'Boolean')
}

workspace.registerButtonCallback('createvariablebool', createVariableBool)

variablesboolFlyoutCallback = function(workspace) {
  var xmlList = [];
  // var blockText = '<button text="Créer une variable de type : logique" callbackKey="createvariablebool"></button>';
  // var block = Blockly.Xml.textToDom(blockText);
  // xmlList.push(block);
  var listevarbool = workspace.getVariablesOfType("Boolean");
  for (var i = 0; i < listevarbool.length; i++) {
    blockText = '<block type="block_get_bool"> <field name="VAR" variabletype="Boolean">' + listevarbool[i].name + '</field> </block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  return xmlList;
};

workspace.registerToolboxCategoryCallback(
  'VARIABLEBOOL', variablesboolFlyoutCallback);

// int

function createVariableInt(button) {
  Blockly.Variables.createVariable(button.getTargetWorkspace(), null, 'Number')
}

workspace.registerButtonCallback('createvariableint', createVariableInt)

variablesintFlyoutCallback = function(workspace) {
  var xmlList = [];
  // var blockText = '<button text="Créer une variable de type : entier" callbackKey="createvariableint"></button>';
  // var block = Blockly.Xml.textToDom(blockText);
  // xmlList.push(block);
  var listevarint = workspace.getVariablesOfType("Number");
  for (var i = 0; i < listevarint.length; i++) {
    blockText = '<block type="block_get_int"> <field name="VAR" variabletype="Number">' + listevarint[i].name + '</field> </block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  return xmlList;
};

workspace.registerToolboxCategoryCallback(
  'VARIABLEINT', variablesintFlyoutCallback);

// string

function createVariableString(button) {
  Blockly.Variables.createVariable(button.getTargetWorkspace(), null, 'String')
}

workspace.registerButtonCallback('createvariablestring', createVariableString)

variablesstringFlyoutCallback = function(workspace) {
  var xmlList = [];
  // var blockText = '<button text="Créer une variable de type : chaine" callbackKey="createvariablestring"></button>';
  // var block = Blockly.Xml.textToDom(blockText);
  // xmlList.push(block);
  var listevarstring = workspace.getVariablesOfType("String");
  for (var i = 0; i < listevarstring.length; i++) {
    blockText = '<block type="block_get_str"> <field name="VAR" variabletype="String">' + listevarstring[i].name + '</field> </block>';
    block = Blockly.Xml.textToDom(blockText);
    xmlList.push(block);
  }
  return xmlList;
};

workspace.registerToolboxCategoryCallback(
  'VARIABLESTRING', variablesstringFlyoutCallback);

ouvrirClick = function () {
  var fileinput = document.getElementById("fileToLoad");
  fileinput.click();
}
ouvrir = function () {
  var fileToLoad = document.getElementById("fileToLoad").files[0];
  var fileReader = new FileReader();
  fileReader.onload = function(fileLoadedEvent) {
		var textFromFileLoaded = fileLoadedEvent.target.result;
		try {
                  Blockly.mainWorkspace.clear();
                  Blockly.Xml.domToWorkspace(Blockly.Xml.textToDom(textFromFileLoaded), workspace);
		} catch (e) {
			alert("Erreur de lecture du XML");
		};
	}
  fileReader.readAsText(fileToLoad, "UTF-8");
}

enregistrer = function() {
  var xml = Blockly.Xml.workspaceToDom(workspace);
  var xml_text = Blockly.Xml.domToPrettyText(xml);
  var textFileAsBlob = new Blob([xml_text], {type:'text/plain'});
  var nom_du_fichier = prompt("Nom du fichier ?");
  var downloadLink = document.createElement("a");
  downloadLink.download = nom_du_fichier+".xml";
  downloadLink.innerHTML = "Download File";
  downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
  downloadLink.onclick = function destroyClickedElement(event) {
                             document.body.removeChild(event.target);
                           };
  downloadLink.style.display = "none";
  document.body.appendChild(downloadLink);
  downloadLink.click();
}
