Blockly.Python['block_print'] = function(block) {
  var msg = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  return 'print(' + msg + ')\n';;
};

Blockly.Python['block_set_bool'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'VALUE',
      Blockly.Python.ORDER_NONE) || '0';
  var varName = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  var code =  varName + ' = ' + argument0 + '\n';
  return code;
};

Blockly.Python['block_set_int'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'VALUE',
      Blockly.Python.ORDER_NONE) || '0';
  var varName = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  var code =  varName + ' = ' + argument0 + '\n';
  return code;
};

Blockly.Python['block_set_str'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'VALUE',
      Blockly.Python.ORDER_NONE) || '0';
  var varName = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  var code =  varName + ' = ' + argument0 + '\n';
  return code;
};

Blockly.Python['block_while'] = function(block) {
  var value_cond = Blockly.Python.valueToCode(block, 'COND', Blockly.Python.ORDER_NONE);
  var inst = Blockly.Python.statementToCode(block, 'INST');
  var code = 'while ' + value_cond + ' :\n' + inst;
  return code;
};

Blockly.Python['block_for'] = function(block) {
  var variable = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var fin = Blockly.Python.valueToCode(block, 'FIN', Blockly.Python.ORDER_NONE);
  var inst = Blockly.Python.statementToCode(block, 'INST');
  var code = 'for '+ variable + ' in range(' + fin + '):\n' + inst;
  return code;
};

Blockly.Python['block_if'] = function(block) {
  var cond = Blockly.Python.valueToCode(block, 'COND', Blockly.Python.ORDER_NONE);
  var inst = Blockly.Python.statementToCode(block, 'INST');
  var code = 'if '+ cond + ' :\n' + inst;
  return code;
};

Blockly.Python['block_ifelse'] = function(block) {
  var cond = Blockly.Python.valueToCode(block, 'COND', Blockly.Python.ORDER_NONE);
  var inst1 = Blockly.Python.statementToCode(block, 'INST1');
  var inst2 = Blockly.Python.statementToCode(block, 'INST2');
  var code = 'if '+ cond + ' :\n' + inst1 + 'else :\n' + inst2;
  return code;
};

Blockly.Python['block_get_bool'] = function(block) {
  var code = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_true'] = function(block) {
  var code = 'True';
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_false'] = function(block) {
  var code = 'False';
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_and'] = function(block) {
  var arg1 = Blockly.Python.valueToCode(block, 'ARG1', Blockly.Python.ORDER_LOGICAL_AND);
  var arg2 = Blockly.Python.valueToCode(block, 'ARG2', Blockly.Python.ORDER_LOGICAL_AND);
  var code = arg1 + ' and ' + arg2;
  return [code, Blockly.Python.ORDER_LOGICAL_AND];
};

Blockly.Python['block_or'] = function(block) {
  var arg1 = Blockly.Python.valueToCode(block, 'ARG1', Blockly.Python.ORDER_LOGICAL_OR);
  var arg2 = Blockly.Python.valueToCode(block, 'ARG2', Blockly.Python.ORDER_LOGICAL_OR);
  var code = arg1 + ' or ' + arg2;
  return [code, Blockly.Python.ORDER_LOGICAL_OR];
};

Blockly.Python['block_not'] = function(block) {
  var arg = Blockly.Python.valueToCode(block, 'ARG', Blockly.Python.ORDER_LOGICAL_NOT);
  var code = 'not ' + arg;
  return [code, Blockly.Python.ORDER_LOGICAL_NOT];
};

Blockly.Python['block_comp'] = function(block) {
  var OPERATORS = {
    'EGAL': ' == ',
    'DIFF': ' != ',
    'INF': ' < ',
    'INFEGAL': ' <= ',
    'SUP': ' > ',
    'SUPEGAL': ' >= '
  };
  var arg1 = Blockly.Python.valueToCode(block, 'ARG1', Blockly.Python.ORDER_RELATIONAL);
  var comp = OPERATORS[block.getFieldValue('COMP')];
  var arg2 = Blockly.Python.valueToCode(block, 'ARG2', Blockly.Python.ORDER_RELATIONAL);
  var code = arg1 + comp + arg2;
  return [code, Blockly.Python.ORDER_RELATIONAL];
};

Blockly.Python['block_get_int'] = function(block) {
  var code = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_get_indice'] = function(block) {
  var code = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_constint'] = function(block) {
  var constante = block.getFieldValue('CONST');
  var code = constante;
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_plus'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_ADDITIVE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_ADDITIVE);
  var code = exp1 + ' + ' + exp2;
  return [code, Blockly.Python.ORDER_ADDITIVE];
};

Blockly.Python['block_minus'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_ADDITIVE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_ADDITIVE);
  var code = exp1 + ' - ' + exp2;
  return [code, Blockly.Python.ORDER_ADDITIVE];
};

Blockly.Python['block_mult'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_MULTIPLICATIVE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_MULTIPLICATIVE);
  var code = exp1 + ' * ' + exp2;
  return [code, Blockly.Python.ORDER_MULTIPLICATIVE];
};

Blockly.Python['block_div'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_MULTIPLICATIVE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_MULTIPLICATIVE);
  var code = exp1 + ' // ' + exp2;
  return [code, Blockly.Python.ORDER_MULTIPLICATIVE];
};

Blockly.Python['block_mod'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_MULTIPLICATIVE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_MULTIPLICATIVE);
  var code = exp1 + ' % ' + exp2;
  return [code, Blockly.Python.ORDER_MULTIPLICATIVE];
};

Blockly.Python['block_pow'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_EXPONENTIATION);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_EXPONENTIATION);
  var code = exp1 + ' ** ' + exp2;
  return [code, Blockly.Python.ORDER_EXPONENTIATION];
};

Blockly.Python['block_neg'] = function(block) {
  var exp = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_UNARY_SIGN);
  var code = '-' + exp;
  return [code, Blockly.Python.ORDER_UNARY_SIGN];
};

Blockly.Python['block_int'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var code = 'int (' + expr + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_len'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var code = 'len (' + expr + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_ord'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var code = 'ord (' + expr + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_randint'] = function(block) {
  var exp1 = Blockly.Python.valueToCode(block, 'EXP1', Blockly.Python.ORDER_NONE);
  var exp2 = Blockly.Python.valueToCode(block, 'EXP2', Blockly.Python.ORDER_NONE);
  var code = 'randint(' + exp1 + ', ' + exp2 + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_get_str'] = function(block) {
  var code = Blockly.Python.variableDB_.getName(block.getFieldValue('VAR'),
      Blockly.Variables.NAME_TYPE);
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_constchaine'] = function(block) {
  var text = block.getFieldValue('STR');
  var code = '"' + text + '"';
  return [code, Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['block_input'] = function(block) {
  var arg = Blockly.Python.valueToCode(block, 'ARG', Blockly.Python.ORDER_NONE);
  var code = 'input (' + arg + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_concat'] = function(block) {
  var str1 = Blockly.Python.valueToCode(block, 'STR1', Blockly.Python.ORDER_ADDITIVE);
  var str2 = Blockly.Python.valueToCode(block, 'STR2', Blockly.Python.ORDER_ADDITIVE);
  var code = str1 + ' + ' + str2;
  return [code, Blockly.Python.ORDER_ADDITIVE];
};

Blockly.Python['block_str'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var code = 'str (' + expr + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};

Blockly.Python['block_chr'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var code = 'chr (' + expr + ')';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};


Blockly.Python['block_nth'] = function(block) {
  var expr = Blockly.Python.valueToCode(block, 'EXP', Blockly.Python.ORDER_NONE);
  var index = Blockly.Python.valueToCode(block, 'INDEX', Blockly.Python.ORDER_NONE);
  var code = expr + '[' + index + ']';
  return [code, Blockly.Python.ORDER_FUNCTION_CALL];
};
